# HAPNUM -- Set all 300 APNUM keywords in a Hectospec multispec file
# By Doug Mink, SAO Telescope Data Center
# November 2, 2006

procedure hapnum (images)

string	images = ""	{prompt="Input multispec images to correct"}
string	apfile="hectospec$lib/apnumset"	{prompt="APNUM setting commands"}
bool	verbose = no	{prompt="Log progress (y or n)"}

begin
	bool vb
	file templist, imin
	int lroot
	string ims, tchar, appath, arg, arg0

	ims = images
	appath = osfn (apfile)
	vb = verbose

	if (!defpac ("wcstools")) {
	    wcstools (motd=no)
	    }

	if (!deftask ("sethead")) {
	    wcstools (motd=no)
	    }

	if (ims == "") {
	    print ("HAPNUM:  Insert APNUMi keywords into header of multispec FITS file")
	    print ("Usage: hapnum <input images>")
	    return
	    }


#  Make temporary list of input files
	tchar = substr (ims,1,1)
        if (tchar == '@') {
	    templist = substr (ims,2,100)
	    }
	else {
	    templist = mktemp ("apnumlist")
	    files (ims, >templist)
	    }
        list = templist
        while (fscan (list,imin) != EOF) {

# Make sure input is a FITS multispec file
	    smatch (imin, ".ms")
	    if (!smatch.found) {
		smatch (imin, ".fits")
		if (smatch.found) {
		    lroot = smatch.start - 1
		    imin = substr (imin, 1, lroot) // ".ms.fits"
		    }
		else {
		    imin = imin // ".ms.fits"
		    }
		if (!access (imin)) {
		    print ("HAPNUM: ", imin," does not exist")
		    next
		    }
		}
	    else {
		smatch (imin, ".fits")
		if (!smatch.found) {
		    imin = imin // ".fits"
		    }
		}

# Fix APNUM keywords
	    arg = imin
	    if (vb) {
		arg = arg // " -v"
		}
	    arg = arg // " @" // appath
	    print ("sethead ",arg)
	    sethead (arg)
	    }

	if (tchar != '@') {
	    delete (templist)
	    }
end

# Nov  2 2006	New program
